# loading-bar.coffee -- this was way easier in flash

$loadingSection = null
$loadingBar = null
$wrapper = null

$ ->
  $loadingSection = $('#loadingSection')
  $loadingBar = $('#loadingBar')

  $wrapper = $loadingBar.find('.wrapper')

  for i in [0..11]
    $wrapper.append($.tag(
      _: 'div'
      class: 'loadingBarSegment'
    ))

window.de.loadingBar =
  phase: 'ready'

  startLoad: ->
    return if phase is not 'ready'

    phase = 'fadeIn'
    $loadingSection.fadeIn(
      2000
      'smoothStepx2'
      ->
        if phase is 'immediateFadeOut' then de.loadingBar.stopLoad()
        else phase = 'loading'
    )

    animBars = ->
      return if phase is 'ready'

      $wrapper.animate(
          marginLeft: '-2em'
        600
        'linear'
        ->
          $wrapper.css('margin-left', 0)
          animBars()
      )
    animBars()

  stopLoad: ->
    if phase is 'fadeIn'
      phase = 'immediateFadeOut'
    else
      phase = 'fadeOut'

      $loadingSection.fadeOut(
        2000
        'smoothStepx2'
        ->
          phase = 'ready'
      )


