$ ->

  # fix kerning on main title
  $('#mainTitle a').lettering()

  # looks nice, but also masks the kerning adjust delay on the lettering plugin
  # and masks the load times on the social images
  $(de.util.img('/images/social.png')).imagesLoaded ->
    selectors = [ '#mainTitle' ]
    selectors.push("#mainMenu .#{section}") for section in [ 'articles', 'design', 'code', 'about' ]
    selectors.push("#socialMenu .#{network}") for network in [ 'twitter', 'github', 'flickr', 'lastfm', 'linkedin' ]
    for selector, i in selectors
      do (selector) ->
        setTimeout((-> $(selector).animate({ opacity: 1 }, 2000, 'smoothStepx3')), 100 * i)

  # wire up main menu
  $('#mainMenu a').click (event) ->
    # aoeu

  # add nonsense divs to the main menu for pretty anim
  $('#mainMenu li').each ->
    $(this).append($.tag(
      _: 'div',
      class: 'animBlock'
    ))

  de.pageTransition(
  #  background: 'f41'
  #  chromeBackground: 'rgba(0, 0, 0, 0.1)'
  #  chromeText: 'rgba(30, 10, 0, 0.6)'
  #  chromeTextShadowAlpha: 0.25
    stageHeight: 200)
  #
  $('a[rel=external]').on('mouseover focus', -> $(this).attr('target', 'blank'))

