# easing.coffee - the easier, the harder

smoothStep = (x) -> x * x * (3 - 2 * x)
selfCompose = (func, times) -> (value) -> [1..times].reduce(func, value)

extensions =
  smoothStep:   selfCompose(smoothStep, 1)
  smoothStepx2: selfCompose(smoothStep, 2)
  smoothStepx3: selfCompose(smoothStep, 3)
  smoothStepxtreeeme: selfCompose(smoothStep, 5)

jQuery.extend(jQuery.easing, extensions)

